<?php
class Aleyant_Edoc_Block_Adminhtml_Document_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
	public function __construct()
	{
		parent::__construct();
		$this->setId('EdocumentGrid');
		$this->setDefaultSort('document_id');
		$this->setDefaultDir('ASC');
		$this->setSaveParametersInSession(true);
		$this->setUseAjax(true);
	}



	protected function _prepareMassaction()
	{
		$this->setMassactionIdField('document_id');
		$this->getMassactionBlock()->setFormFieldName('document');

		$this->getMassactionBlock()->addItem('process', array(
				'label'    => Mage::helper('edoc')->__('Process'),
				'url'      => $this->getUrl('*/*/massProcess'),
				'confirm'  => Mage::helper('edoc')->__('Are you sure to process?')
		));

		$this->getMassactionBlock()->addItem('Delete', array(
				'label'    => Mage::helper('edoc')->__('Delete'),
				'url'      => $this->getUrl('*/*/massDelete'),
				'confirm'  => Mage::helper('edoc')->__('Are you sure to delete ?')
		));

		$this->getMassactionBlock()->addItem('VarData', array(
				'label'    => Mage::helper('edoc')->__('Var Data'),
				'url'      => $this->getUrl('*/*/massData'),
		));



		$this->getMassactionBlock()->addItem('Approve', array(
				'label'    => Mage::helper('edoc')->__('Approve'),
				'url'      => $this->getUrl('*/*/massApprove'),
				'confirm'  => Mage::helper('edoc')->__('Are you sure to send for approval?')
		));



		return $this;
	}

	protected function _prepareCollection()
	{
		$collection = Mage::getModel('edoc/document')->getCollection();
		$this->setCollection($collection);
		return parent::_prepareCollection();
	}

	protected function _prepareColumns()
	{
		$this->addColumn('document_id', array(
				'header'    => Mage::helper('edoc')->__('ID'),
				'align'     =>'right',
				'width'     => '50px',
				'index'     => 'document_id',
		));


		$this->addColumn('downloadlink', array(
				'header'    => Mage::helper('edoc')->__('Download'),
				'align'     =>'right',
				'width'     => '250px',
				'index'     => 'downloadlink',
				'renderer' => 'Aleyant_Edoc_Block_Adminhtml_Document_Grid_Renderer_Downloadlink'

				));

		$this->addColumn('varlink', array(
				'header'    => Mage::helper('edoc')->__('VarData'),
				'align'     =>'right',
				'width'     => '250px',
				'index'     => 'varlink',
				'renderer' => 'Aleyant_Edoc_Block_Adminhtml_Document_Grid_Renderer_Varlink'

		));


		$this->addColumn('Order#', array(
				'header'    => Mage::helper('edoc')->__('Orderid'),
				'align'     =>'left',
				'index'     => 'incrementid',
				'width'     => '100px',

				));


		$this->addColumn('itemid', array(
				'header'    => Mage::helper('edoc')->__('Itemid'),
				'align'     =>'left',
				'index'     => 'itemid',
				'width'     => '100px',
				'renderer' => 'Aleyant_Edoc_Block_Adminhtml_Document_Grid_Renderer_Item'


				));


		$this->addColumn('created_at', array(
				'header'    => Mage::helper('edoc')->__('Creation Time'),
				'align'     => 'left',
				'width'     => '120px',
				'type'      => 'date',
				'default'   => '--',
				'index'     => 'created_at',
		));

		$this->addColumn('updated_at', array(
				'header'    => Mage::helper('edoc')->__('Update Time'),
				'align'     => 'left',
				'width'     => '120px',
				'type'      => 'date',
				'default'   => '--',
				'index'     => 'updated_at',
		));


		$this->addColumn('status', array(

				'header'    => Mage::helper('edoc')->__('Status'),
				'align'     => 'left',
				'width'     => '80px',
				'index'     => 'status',
				'type'      => 'options',
				'options'   => array(
						0 => 'Invalid',
						1 => 'Pending',
						2 => 'Processed',
						3 => 'Failed',
					    4 => 'Finalized'

				),
		));

		$this->addColumn('varstatus', array(

				'header'    => Mage::helper('edoc')->__('VarData Status'),
				'align'     => 'left',
				'width'     => '80px',
				'index'     => 'varstatus',
				'type'      => 'options',
				'options'   => array(
						0 => '-',
						1 => 'Pending',
						2 => 'Available',
						3 => 'n/a',

				),
		));


		return parent::_prepareColumns();
	}

	public function getRowUrl($row)
	{
		return Mage::helper('adminhtml')->getUrl('adminhtml/sales_order/view', array('order_id' => $row->getOrderid()));
	}

	public function getGridUrl()
	{
		return $this->getUrl('*/*/grid', array('_current'=>true));
	}


}