<?php

class Aleyant_Edoc_Block_Adminhtml_Template_Grid extends Mage_Adminhtml_Block_Widget_Grid {

    public function __construct() 
	{
        parent::__construct();
        $this->setId('templateGrid');
        $this->setDefaultSort('template_id');
        $this->setDefaultDir('ASC');
        $this->setSaveParametersInSession(true);
    }

    protected function _prepareCollection() 
	{
        $collection = Mage::getModel('edoc/template')->getCollection();
        $this->setCollection($collection);
        return parent::_prepareCollection();
    }

    protected function _prepareColumns() 
	{
        $this->addColumn('template_id', array(
            'header' => Mage::helper('edoc')->__('ID'),
            'align' => 'center',
            'width' => '50px',
            'index' => 'template_id',
        ));

        $this->addColumn('docname', array(
            'header' => Mage::helper('edoc')->__('Document Name'),
            'align' => 'left',
            'index' => 'docname',
        ));
        
        $this->addColumn('docid', array(
            'header' => Mage::helper('edoc')->__('Document ID'),
            'align' => 'left',
            'index' => 'docid'
        ));
        
        $this->addColumn('docpass', array(
            'header' => Mage::helper('edoc')->__('Document Pass'),
            'align' => 'left',
            'index' => 'docpass'
        ));

       
        $this->addColumn('status', array(
            'header' => Mage::helper('edoc')->__('Is Active'),
            'index' => 'status',
            'type' => 'options',
            'options' =>  $this->getStatusOption(),
        ));
        

        return parent::_prepareColumns();
    }

    protected function _prepareMassaction() 
	{
        $this->setMassactionIdField('template');
        
        $this->getMassactionBlock()->setFormFieldName('edoc');

        $this->getMassactionBlock()->addItem('delete', array(
            'label' => Mage::helper('edoc')->__('Delete'),
            'url' => $this->getUrl('*/*/massDelete'),
            'confirm' => Mage::helper('edoc')->__('Are you sure?')
        ));
        
        $this->getMassactionBlock()->addItem('status', array(
            'label' => Mage::helper('edoc')->__('Is Active'),
            'url' => $this->getUrl('*/*/massStatus', array('_current' => true)),
            'additional' => array(
                'visibility' => array(
                    'name' => 'status',
                    'type' => 'select',
                    'class' => 'required-entry',
                    'label' => Mage::helper('edoc')->__('Is Active'),
                    'values' => $this->getStatusOption()
                )
            )
        ));
        return $this;
    }

    private function getStatusOption() 
	{
        return array(
            1 => Mage::helper('edoc')->__('YES'),
            0 => Mage::helper('edoc')->__('NO')
        );
    }
    
    public function getRowUrl($row) 
	{
        return $this->getUrl('*/*/edit', array('id' => $row->getId()));
    }

}
