<?php

class Aleyant_Edoc_Helper_Data extends Mage_Core_Helper_Abstract {

	/**
	 * Gets config vars
	 * @param string $key
	 * @param string $field
	 * @return mixed
	 */
	public function getConfig($key, $field = 'defaultconfig') {
//		$this->_storeId = Mage::app ()->getStore ()->getStoreId ();
		return trim(Mage::getStoreConfig ( 'aleyantsection/' . $field . '/' . $key ));
	}

	/*
	 * Sets config var field: defaultconfig, adminconfig, downloadconfig
	 */
	public function setConfig($key,$field,$value){

	Mage::getConfig()->saveConfig('aleyantsection/' . $field . '/' . $key, $value);

	}
	public function log($msg){

		if($msg){
			Mage::log('edoc approve state $st  current orderstate '.$order->getState(),null,"edoc.log");

		}
	}

	public function getPrv($sess)
	{
		$size = Mage::helper('edoc')->getConfig('img_size','soapconfig');

		try {
			$endpoint = Mage::helper('edoc')->getConfig('endpoint', 'soapconfig');
			$client = new SoapClient($endpoint, array('cache_wsdl' => WSDL_CACHE_DISK));

			$response = $client->__soapCall(
					'getPreviews',
					array(
							'getPreviews' => array(
									'docSessionID' => $sess,
									'pageNumber' => array(
											'int' => array(1,1)
									),
									'pixelSize' => $size,
									'includeThumbs' => true

							)
					)
			);



			$views = (array)$response->getPreviewsResult->docPreviewPage;
            
			if(isset($views['thumbURL'])){
			    
			    return array($views['thumbURL'], $views['largeURL']);
			}
			
			foreach($views as $v){
				$v = (array)$v;
				if(isset($v['thumbURL'])){
				return array($v['thumbURL'], $v['largeURL']);
				}
			}


		}catch(SoapFault $e){
			Mage::logException($e);
		}
		catch(Exception $e){
			Mage::logException($e);
		}

		return false;

	}



	public function approve($sess)
	{

		$st = Mage::helper('edoc')->getConfig('edoc_timeout','soapconfig');



		$endpoint = Mage::helper('edoc')->getConfig('endpoint', 'soapconfig');

		$params = array ('encoding' => 'UTF-8', 'verifypeer' => false, 'verifyhost' => false, 'soap_version' => SOAP_1_2,  'exceptions' => 1, "connection_timeout" => $st );

		//$client = new SoapClient($endpoint, array('cache_wsdl' => WSDL_CACHE_DISK));

		try{
		$client = new SoapClient($endpoint, $params);

		$response = $client->__soapCall('approveDocSession', array('approveDocSession' => array('docSessionID' => $sess)));


		///		Mage::log("doc approval ".$response->approveDocSessionResult->approvalStatus);


		if ($response->approveDocSessionResult->approvalStatus) {

			return true;

		}
		Mage::log('edoc approve  soap error for '.$sess,null,"edoc.log");


		return false;

		}catch(Exception $e){

			Mage::log('edoc approve  soap exception for '.$sess.'   '.$e->getMessage(),null,"edoc.log");

		}
		return false;

	}



}