<?php
class Aleyant_Edoc_Model_Importer
{


	public  function getTemplates()
	{
		try{
		$user = Mage::helper('edoc')->getConfig('username','adminconfig');
		$pass = Mage::helper('edoc')->getConfig('password','adminconfig');


		$st = Mage::helper('edoc')->getConfig('edoc_timeout','soapconfig');
		$endpoint = Mage::helper('edoc')->getConfig('endpoint', 'soapconfig');
		$params = array ('encoding' => 'UTF-8', 'verifypeer' => false, 'verifyhost' => false, 'soap_version' => SOAP_1_2,  'exceptions' => 1, "connection_timeout" => $st );
		$client = new SoapClient($endpoint, $params);



		$response = $client->__soapCall('getLibraryTemplates', array('LibraryTemplates' => array('email' => $user,'password' => $pass)));

		if (!is_object($response->getLibraryTemplatesResult)){
			throw new Exception("Cron::AleyantEdocImport:Error response");
		}
		$templates = (array)$response->getLibraryTemplatesResult->libraryTemplate;

		foreach($templates as $t){
			$t = (array)$t;
			$tps = Mage::getModel('edoc/template')->getCollection()->addFieldToFilter('docid', array('like' => $t['docID']));
			$tp = $tps->load()->getFirstItem();

			if ($tp && $tp->getTemplateId()) {
				$this->log("Template ".$t['docName']." exist");
				if (!$t['isActive']) {

					Mage::getModel('edoc/template')->load($tp->getTemplateId())->delete();
					$this->log("Template ".$t['docName']." deleted due to inactive in eDocBuilder.");

					//$this->log("Template ".$t['docName']." inactive setting status to inactive.");
					//$tp->setStatus(false);
					//$tp->save();

					continue;
				}
			} else {
				if (!$t['isActive']) {
					$this->log("Template ".$t['docName']." inactive");
					continue;
				}
				$tp = Mage::getModel('edoc/template');
				$tp->setDocname($t['docName']);
				$tp->setDocid($t['docID']);
				$tp->setDocpass($t['docPassword']);
				$tp->setDocdes($t['docDescription']);
				$tp->setStatus(true);
				$tp->save();
			}


		}


		Mage::helper('edoc')->setConfig('last_import','defaultconfig',date('Y-m-d H:i:s'));
		}catch(Exception $e){
			print $e->getTraceAsString();

			Mage::log("import error ".$e->getMessage(),null,"edoc.log");

		}

	}
	private function log($msg)
	{
echo $msg."\n";

	}

}