<?php

class Aleyant_Edoc_Model_Observer
{
	private function log($m)
	{
		echo $m;

	}

	public  function runCron()
	{
		$cr = Mage::helper('edoc')->getConfig('cronrunning');
		$cr = trim($cr);
		if ($cr){
			echo "\ncronrunning $cr\n";
			return;
		}
		Mage::helper('edoc')->setConfig('cronrunning', 'defaultconfig', '1');
		echo "\nstart\n";
		$import = Mage::helper('edoc')->getConfig('import_cron');
		$import = trim($import);
		try {
			if ($import){

				$dt = Mage::helper('edoc')->getConfig('import_date');
				$tm = Mage::helper('edoc')->getConfig('import_time');
				list($h, $m, $s) = explode(",", $tm);

				$str = " +{$h} hour {$m} minute {$s} second";
				$time = strtotime($dt.$str);

				if ($time<time()) {
					$this->log("will import documents");
					$cl = new Aleyant_Edoc_Model_Importer();
					$cl->getTemplates();
					Mage::helper('edoc')->setConfig('import_cron', 'defaultconfig', false);
					$this->log("Import complete");
					Mage::helper('edoc')->setConfig('cronrunning', 'defaultconfig', false);
					Mage::helper('edoc')->setConfig('last_import', 'defaultconfig', Zend_Date::now()->toString('Y-M-d H:m:s'));

					return;
				}




			}

			$download = Mage::helper('edoc')->getConfig('down_cron');

			if ($download){
				$this->docProcessCron();
			}

			echo "\ncron finished\n";


		} catch(Mage_Exception $e){
			Mage::logException($e);
		}

		Mage::helper('edoc')->setConfig('cronrunning', 'defaultconfig', false);



	}

	public function docProcessCron()
	{   $i=0;

		$cr = Mage::helper('edoc')->getConfig('cronrunning');
		$cr = trim($cr);
		if ($cr){
Mage::log("download cron running",null,"edoc.log");
			return;
		}

		Mage::helper('edoc')->setConfig('cronrunning', 'defaultconfig', '1');

		try{

		$size = Mage::helper('edoc')->getConfig('down_size', 'defaultconfig');
		$user = Mage::helper('edoc')->getConfig('username', 'adminconfig');
		$pass = Mage::helper('edoc')->getConfig('password', 'adminconfig');
		///echo "document processing cron running for $size documents email $user pass $pass\n";

		$collection = Mage::getModel('edoc/document')->getCollection();
		$collection->addFieldToFilter('status', 1);
		$collection->setCurPage(1)->setPageSize($size);


		$st = Mage::helper('edoc')->getConfig('edoc_timeout','soapconfig');
		$endpoint = Mage::helper('edoc')->getConfig('endpoint', 'soapconfig');
		$params = array ('encoding' => 'UTF-8', 'verifypeer' => false, 'verifyhost' => false, 'soap_version' => SOAP_1_2,  'exceptions' => 0, "connection_timeout" => $st );


		foreach($collection as $document){
			//Mage::log("Processing document ID ".$document->getDocumentId());


			$doc = Mage::getModel('edoc/document')->load($document->getDocumentId());

			$client = new SoapClient($endpoint, $params);

			$response = $client->__soapCall(
				'getOrderFIle',
				array(
					'OrderFIle' => array(
						'email' => $user,
						'password' => $pass,
						'docSessionID' => $doc->getSess()
					)
				)
			);

			if(!$response||!property_exists($response, 'getOrderFileResult')){

				continue;

			}

			$doc->setDownloadlink($response->getOrderFileResult);
			$doc->setUpdatedAt(new Zend_Db_Expr('NOW()'));

			if ($response->getOrderFileResult&&preg_match('/^http/',$response->getOrderFileResult)){
				$doc->setStatus(2);


				$response = $client->__soapCall(
						'getVdpDataFileInfo',
						array(
								'VdpDataFileInfo' => array(
										'sessionID' => $doc->getSess()
								)
						)
				);

				if(!$response||!property_exists($response, 'getVdpDataFileInfoResult')){


				}else{
				$i++;
				$variableData=$response->getVdpDataFileInfoResult;
				if ($variableData&&property_exists($variableData, 'fileURL')&&$variableData->numRecords){

				$doc->addData(['varlink' => $variableData->fileURL, 'varnum' => $variableData->numRecords,'varstatus'=>2]);

				}else{
					$doc->setVarstatus(3);
				}
				}



				///$i++;
			} else{
				$doc->setStatus(3);
			}


			$doc->save();



		}

		Mage::helper('edoc')->setConfig('last_download','defaultconfig',date('Y-m-d H:i:s'));
		}catch(Exception $e){

			print $e->getTraceAsString();

			Mage::log("download cron error".$e->getMessage(),null,"edoc.log");

		}

		Mage::helper('edoc')->setConfig('cronrunning', 'defaultconfig', '0');


	}


/**
 * check for order status and if matches edoc approval status setting then send approve request.
 * 
 * @param unknown $observer
 * @return void|Aleyant_Edoc_Model_Observer
 */




	public function saveOrder($observer)
	{
		Mage::log("saving order saveOrder",null,'edoc.log');


		$order = $observer->getDataObject();
		if(!$order){
			Mage::log("edoc order not found",null,"edoc.log");

			return;
		}

		$st = Mage::helper('edoc')->getConfig('edoc_process');
		if(!$st){
			Mage::log("state not configured",null,"edoc.log");
			return;
		}


		$status=$order->getStatus();
		Mage::log("saveORder: edoc approve status set to: $st  current orderstate is:".$order->getStatus(),null,"edoc.log");

		if ($status == $st) {
			$items = $order->getAllItems();

			/* @var $item Mage_Sales_Model_Order_Item */

			$edoc = false;
			$onh=false;
			foreach($items as $item) {
				$product = Mage::getModel('catalog/product')->load($item->getProductId());
				if ($product->getTypeId()==Aleyant_Edoc_Model_Product_Type_Edoc::TYPE_EDOC_PRODUCT){

					$opts=$item->getProductOptions();
					$br=$opts['info_buyRequest'];
					//document  is already approved.
					if(isset($br['approved'])&&$br['approved']){
						continue;
					}

					$sess=isset($br['sess'])?$br['sess']:'';
					


					if ($sess){
                            //send and check approval
							if(!Mage::helper('edoc')->approve($sess)){

							    //rejected status
							    $onh=true;
								$opts['info_buyRequest']['edoc_invalid']=1;
								$item->setProductOptions($opts);
								$item->save();
								$doc=	Mage::getModel('edoc/document')->load($order->getId(),'orderid');
								$doc->setOrderid($order->getId());
								$doc->setIncrementid($order->getIncrementId());
								$doc->setItemid($item->getId());
								$doc->setSess($sess);
								$doc->setCreatedAt(new Zend_Db_Expr('NOW()'));
								$doc->setStatus(0);
								$doc->save();
								Mage::log("Invalid session, or edoc not approved for:  ".$order->getIncrementId(),null,"edoc.log");



								continue;
							}
						//document approved.	
						unset($opts['info_buyRequest']['invalid']);
						$opts['info_buyRequest']['approved']=1;
						$item->setProductOptions($opts);
						$item->save();
						$doc=	Mage::getModel('edoc/document')->load($order->getId(),'orderid');
						$doc->setOrderid($order->getId());
						$doc->setIncrementid($order->getIncrementId());
						$doc->setItemid($item->getId());
						$doc->setSess($sess);
						$doc->setCreatedAt(new Zend_Db_Expr('NOW()'));
						$doc->setStatus(1);
						$doc->save();
						Mage::log("edoc saved for:".$order->getIncrementId(),null,"edoc.log");

					}else{

					    //put order on hold if no session info.
						Mage::log('Session info not found for  '.$item->getName()." order# ".$order->getIncrementId(),null,"edoc.log");

						$onh=true;
						$opts['info_buyRequest']['invalid']=1;
						$item->setProductOptions($opts);
						$item->save();

					}
				}
			}
			if($onh){
					try{
				$order->hold();
				$order->getResource()->save($order);
					}catch(Exception $e){
Mage::log("cannot hold order ".$order->getId()." error ".$e->getMessage(),null,"edoc.log");
					}


			}
		}
		return $this;
	}







}