<?php

class Aleyant_Edoc_Adminhtml_DocumentController extends Mage_Adminhtml_Controller_Action
{

	public function indexAction()
	{
		$this->loadLayout();
		$this->renderLayout();
	}

	public function orderAction()
	{

		$orderid = $this->getRequest()->get('order_id');
		$coll = Mage::getModel('edoc/document')->getCollection();
		$coll->addFieldToFilter('orderid',$orderid);
		$coll->load();
		Mage::register('aleyant_docs', $coll);
		$this->loadLayout();
		$this->getResponse()->setBody(
				$this->getLayout()->createBlock('edoc/adminhtml_documents')->toHtml()
		);
	}


	/**
	 * Product grid for AJAX request.
	 * Sort and filter result for example.
	 */
	public function gridAction()
	{
		$this->loadLayout();
		$this->getResponse()->setBody(
				$this->getLayout()->createBlock('edoc/adminhtml_document_grid')->toHtml()
		);
	}

	public function massDeleteAction()
	{
	    $cr = Mage::helper('edoc')->getConfig('cronrunning','defaultconfig');
	    
		if($cr=="false") $cr=false;

		if ($cr){
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('edoc')->__('Cron job is running. try after it finishes.'.$cr));
			$this->_redirect('*/*/index');
			return;
		}

		Mage::helper('edoc')->setConfig('cronrunning','defaultconfig',true);
		$ids = $this->getRequest()->getParam('document');
		// $this->getMassactionBlock()->setFormFieldName('tax_id'); from Mage_Adminhtml_Block_Tax_Rate_Grid
		if (!is_array($ids)) {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('edoc')->__('Please select documents.'));
		} else {
			try {
				$i = 0;

				foreach($ids as $id){
					$n = Varien_Date::now();
					$n = time();
					$doc = Mage::getModel('edoc/document')->load($id);
					if ($doc->getStatus() != 2 && $doc->getStatus() != 1) {
						$doc->delete();
						$i++;
					}
				}

				Mage::getSingleton('adminhtml/session')->addSuccess(
					Mage::helper('edoc')->__(
						'Total of %d documents were deleted.', $i
					)
				);
			}
			catch (Exception $e) {
				Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
			}
		}
		Mage::helper('edoc')->setConfig('cronrunning',false);

		$this->_redirect('*/*/index');
	}


	public function massDataAction(){

	    $cr = Mage::helper('edoc')->getConfig('cronrunning','defaultconfig');
	    if($cr=="false") $cr=false;


		if ($cr){
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('edoc')->__('Cron job is running. try after it finishes.'));
			$this->_redirect('*/*/index');
			return;
		}

		Mage::helper('edoc')->setConfig('cronrunning','defaultconfig',true);

		$ids = $this->getRequest()->getParam('document');



		try {
			$i = 0;
			$user = Mage::helper('edoc')->getConfig('username', 'adminconfig');
			$pass = Mage::helper('edoc')->getConfig('password', 'adminconfig');
			$endpoint = Mage::helper('edoc')->getConfig('endpoint', 'soapconfig');
			$st = Mage::helper('edoc')->getConfig('edoc_timeout','soapconfig');
			$params = array ('encoding' => 'UTF-8', 'verifypeer' => false, 'verifyhost' => false, 'soap_version' => SOAP_1_2,  'exceptions' => 0, "connection_timeout" => $st );

			$client = new SoapClient($endpoint, $params);

			foreach($ids as $id){
				$doc = Mage::getModel('edoc/document')->load($id);
				if ($doc->getStatus() !=2 ||$doc->getVarstatus()==2){
					continue;
				}


				$response = $client->__soapCall(
						'getVdpDataFileInfo',
						array(
								'VdpDataFileInfo' => array(
										'sessionID' => $doc->getSess()
								)
						)
				);

				if(!$response||!property_exists($response, 'getVdpDataFileInfoResult')){
					continue;

				}

$i++;
$variableData=$response->getVdpDataFileInfoResult;

if ($variableData&&property_exists($variableData, 'fileURL')&&$variableData->numRecords){


					$doc->addData(['varlink' => $variableData->fileURL, 'varnum' => $variableData->numRecords,'varstatus'=>2]);

				}else{
					$doc->setVarstatus(3);
				}
				$doc->save();






			}

			Mage::getSingleton('adminhtml/session')->addSuccess(
					Mage::helper('edoc')->__(
							'Total of %d documents were processed.', $i
					)
			);


		} catch (Exception $e) {
			Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
		}


		Mage::helper('edoc')->setConfig('cronrunning','defaultconfig',false);







		$this->_redirect('*/*/index');


	}

	public function massFinalAction()
	{

	    $cr = Mage::helper('edoc')->getConfig('cronrunning','defaultconfig');
	    
	    if($cr=="false") $cr=false;


		if ($cr){
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('edoc')->__('Cron job is running. try after it finishes.'));
			$this->_redirect('*/*/index');
			return;
		}

		Mage::helper('edoc')->setConfig('cronrunning','defaultconfig',true);

		$ids = $this->getRequest()->getParam('document');
		// $this->getMassactionBlock()->setFormFieldName('tax_id'); from Mage_Adminhtml_Block_Tax_Rate_Grid
		if (!is_array($ids)) {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('edoc')->__('Please select documents.'));
		} else {
			try {
				$i=0;

				foreach($ids as $id){
					$n = Varien_Date::now();
					$n = time();
					$doc = Mage::getModel('edoc/document')->load($id);
		              if ($doc->getStatus()==2){
						$i++;
		              	$doc->setStatus(4);
		              	$doc->setUpdatedAt(new Zend_Db_Expr('NOW()'));
		              	$doc->save();
		              }
				  }




				Mage::getSingleton('adminhtml/session')->addSuccess(
					Mage::helper('edoc')->__(
						'Total of %d documents were finalized.'.$n, $i
					)
				);
			}
			catch (Exception $e) {
				Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
			}
		}
		Mage::helper('edoc')->setConfig('cronrunning','defaultconfig',false);

		$this->_redirect('*/*/index');
	}


	public function massApproveAction()
	{
	    $cr = Mage::helper('edoc')->getConfig('cronrunning','defaultconfig');
	    if($cr=="false") $cr=false;

		if ($cr){
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('edoc')->__('Cron job is running. try after it finishes.'));
			$this->_redirect('*/*/index');
			return;
		}

		Mage::helper('edoc')->setConfig('cronrunning','defaultconfig',true);

		$ids = $this->getRequest()->getParam('document');
		if (!is_array($ids)) {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('edoc')->__('Please select documents.'));
		} else {
			try {
				$i = 0;
				$user = Mage::helper('edoc')->getConfig('username', 'adminconfig');
				$pass = Mage::helper('edoc')->getConfig('password', 'adminconfig');
				$endpoint = Mage::helper('edoc')->getConfig('endpoint', 'soapconfig');
				$st = Mage::helper('edoc')->getConfig('edoc_timeout','soapconfig');
				$params = array ('encoding' => 'UTF-8', 'verifypeer' => false, 'verifyhost' => false, 'soap_version' => SOAP_1_2,  'exceptions' => 0, "connection_timeout" => $st );
				$client = new SoapClient($endpoint, $params);


				foreach($ids as $id){
					$doc = Mage::getModel('edoc/document')->load($id);
					if ($doc->getStatus() == 0){
						$client = new SoapClient($endpoint, $params);
						$response = $client->__soapCall(
							'approveDocSession',
							array(
								'approveDocSession' => array(
									'docSessionID' => $doc->getSess()
								)
							)
						);
						if(!$response||!property_exists($response,'approveDocSessionResult')){
							continue;
						}

						if ($response->approveDocSessionResult->approvalStatus){
							$doc->setStatus(1);
							$doc->setUpdatedAt(new Zend_Db_Expr('NOW()'));

							$doc->save();
							$i++;
						}
					}

				}
				Mage::getSingleton('adminhtml/session')->addSuccess(
					Mage::helper('edoc')->__(
						'Total of %d documents were approved.', $i
					)
				);
			} catch (Exception $e) {
				Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
			}
		}
		Mage::helper('edoc')->setConfig('cronrunning','defaultconfig',false);

		$this->_redirect('*/*/index');



	}


	public function newAction()
	{
		try {
			$this->loadLayout();
			$this->_title($this->__("Edocbuilder Help."));
			$this->renderLayout();
		}
		catch (Exception $e) {
    		Mage::printException($e);
		}
	}



	public function massProcessAction()
	{

	    $cr = trim(Mage::helper('edoc')->getConfig('cronrunning','defaultconfig'));
		if($cr=="false") $cr=false;
		if ($cr) {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('edoc')->__('Cron job is running. try after it finishes.'));
			$this->_redirect('*/*/index');
			return;
		}

		Mage::helper('edoc')->setConfig('cronrunning','defaultconfig',true);
		$ids = $this->getRequest()->getParam('document');
		if (!is_array($ids)) {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('edoc')->__('Please select documents.'));
		} else {
			try {
				$i = 0;
				$user = Mage::helper('edoc')->getConfig('username','adminconfig');
				$pass = Mage::helper('edoc')->getConfig('password','adminconfig');
				$endpoint = Mage::helper('edoc')->getConfig('endpoint', 'soapconfig');
				$st = Mage::helper('edoc')->getConfig('edoc_timeout','soapconfig');
				$params = array ('encoding' => 'UTF-8', 'verifypeer' => false, 'verifyhost' => false, 'soap_version' => SOAP_1_2,  'exceptions' => 0, "connection_timeout" => $st );



				foreach($ids as $id){
					$doc = Mage::getModel('edoc/document')->load($id);
					if($doc->getStatus()==2){
						continue;
					}

					$client = new SoapClient($endpoint, $params);

					$response = $client->__soapCall(
						'getOrderFile',
						array(
							'OrderFile' => array(
								'email' => $user,
								'password' => $pass,
								'docSessionID' => $doc->getSess()
							)
						)
					);

					if(!$response||!property_exists($response, 'getOrderFileResult')){
						continue;
					}

					$doc->setDownloadlink($response->getOrderFileResult);

					if ($response->getOrderFileResult&&preg_match('/^http/',$response->getOrderFileResult)){

					try{





						$response = $client->__soapCall(
								'getVdpDataFileInfo',
								array(
										'VdpDataFileInfo' => array(
												'sessionID' => $doc->getSess()
										)
								)
						);

						if(!$response||!property_exists($response, 'getVdpDataFileInfoResult')){


						}else{
							$variableData=$response->getVdpDataFileInfoResult;

							if ($variableData&&property_exists($variableData, 'fileURL')&&$variableData->numRecords){
							$doc->addData(['varlink' => $variableData->fileURL, 'varnum' => $variableData->numRecords,'varstatus'=>2]);

						}else{
							$doc->setVarstatus(3);
						}

						}




					}catch(Exception $e){


					}




					$doc->setUpdatedAt(new Zend_Db_Expr('NOW()'));

						$doc->setStatus(2);
						$i++;
					} else{
						$doc->setStatus(3);
					}
					$doc->save();
				}
				Mage::getSingleton('adminhtml/session')->addSuccess(
					Mage::helper('edoc')->__(
						'Total of %d documents were generated.', $i
					)
				);
			} catch (Exception $e) {
				Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
			}
		}

		Mage::helper('edoc')->setConfig('cronrunning','defaultconfig',false);

		$this->_redirect('*/*/index');
	}

}