<?php

class Aleyant_Edoc_Adminhtml_TemplateController extends Mage_Adminhtml_Controller_Action
{
	
    public function indexAction()
    {
    	$this->_title($this->__('Template Manager'))->_title($this->__('Template Manager'));
        $this->loadLayout();
        $this->_setActiveMenu('edoc/template');
        $this->_addBreadcrumb($this->__('Template Manager'), $this->__('Template Manager'));
        $this->renderLayout();
    }

    public function editAction()
    {
        $id = $this->getRequest()->getParam('id');
        $model = Mage::getModel('edoc/template')->load($id);

        if ($model->getId() || $id == 0) {
            $data = Mage::getSingleton('adminhtml/session')->getFormData(true);
            if (!empty($data)) {
                $model->setData($data);
            }
            Mage::register('edoc_template', $model);
            $this->loadLayout();
            $this->_setActiveMenu('edoc/template');
            
            $this->_addBreadcrumb($this->__('Template Manager'), $this->__('Template Manager'));
            
            $this->_addContent($this->getLayout()->createBlock('edoc/adminhtml_template_edit'))
                ->_addLeft($this->getLayout()->createBlock('giftcards/adminhtml_template_edit_tabs'));
                
            $this->renderLayout();
            
        } else {
            Mage::getSingleton('adminhtml/session')->addError(Mage::helper('giftcards')->__('Template does not exists'));
            $this->_redirect('*/*/');
        }
    }

    public function newAction()
    {
        $this->editAction();
    }


    public function saveAction()
    {
        if ($data = $this->getRequest()->getPost()) {
            $model = Mage::getModel('edoc/template');
            $model->setData($data);
            $model->setId($this->getRequest()->getParam('id'));
            // set card ready for activate
            // $model->setCardStatus(2);
            try {
                $model->save();
                Mage::getSingleton('adminhtml/session')->addSuccess($this->__('Template was successfully saved'));
                Mage::getSingleton('adminhtml/session')->setFormData(false);
                $this->_redirect('*/*/');
                return;
            } catch (Exception $e) {
                Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
                Mage::getSingleton('adminhtml/session')->setFormData($data);
                $this->_redirect('*/*/edit', array(
                    'id' => $this->getRequest()->getParam('id')
                ));
                return;
            }
        }
        Mage::getSingleton('adminhtml/session')->addSuccess($this->__('Unable find gift card to save'));
        $this->_redirect('*/*/');
    }

    public function deleteAction()
    {
        if (($id = $this->getRequest()->getParam('id')) > 0) {
            try {
                Mage::getModel('edoc/template')->load($id)->delete();
                Mage::getSingleton('adminhtml/session')->addSuccess($this->__('Template was successfully deleted'));
                $this->_redirect('*/*/');
            } catch (Exception $e) {
                Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
                $this->_redirect('*/*/edit', array('id' => $this->getRequest()->getParam('id')));
            }
        }
        $this->_redirect('*/*/');
    }

    public function massDeleteAction()
    {
        $templateIds = $this->getRequest()->getParam('edoc');
        if (!is_array($templateIds)) {
            $this->_getSession()->addError($this->__('Please select template(s)'));
        } else {
            try {
                foreach ($templateIds as $templateId) {
                    Mage::getModel('edoc/template')->load($templateId)->delete();
                }
                $this->_getSession()->addSuccess(
                    $this->__('Total of %d template(s) were successfully deleted', count($templateIds))
                );
            } catch (Exception $e) {
                $this->_getSession()->addError($e->getMessage());
            }
        }
        $this->_redirect('*/*/');
    }
    
    
    /**
     * Mass Status Change
     */
    public function massStatusAction() 
	{
        $templateIds = $this->getRequest()->getParam('edoc');
        if (!is_array($templateIds)) {
            $this->_getSession()->addError($this->__('Please select template(s)'));
        } else {
            try {

                foreach ($templateIds as $templateId) {
                    $model = Mage::getModel('edoc/template')->load($templateId);
                    $model->setStatus($this->getRequest()->getParam('status'))
                            ->setIsMassupdate(true)
                            ->save();
                }
                $this->_getSession()->addSuccess(
                        $this->__('Total of %d template(s) were successfully updated', count($templateId))
                );
            } catch (Exception $e) {
                $this->_getSession()->addError($e->getMessage());
            }
        }
        $this->_redirect('*/*/index');
    }

}