<?php
class Aleyant_Edoc_IndexController extends Mage_Core_Controller_Front_Action
{

	public function reopenAction()
	{

		try {
			$sess = $this->getRequest()->get('item','');
			$cartid = $this->getRequest()->get('cartid','');
			if (!$cartid){
				$this->_redirect('');
				return;
			}
			/* @var $cart Mage_Checkout_Model_Cart */


			$store = Mage::app()->getStore()->getId();

			if (!$sess||!$cartid) {
				throw new Exception('invalid request');
			}

			$endpoint = Mage::helper('edoc')->getConfig('endpoint', 'soapconfig');
			$client = new SoapClient($endpoint, array('cache_wsdl' => WSDL_CACHE_DISK));
			$response = $client->__soapCall('reOpenSession', array('reOpenSession' => array('docSessionID' => $sess)));

			if ($response->reOpenSessionResult) {
				$cart = Mage::getSingleton('checkout/cart');
				$cart->init();
				$item = $cart->getItems()->getItemById($cartid);
				if(!$item){
					throw new Exception('invalid request.no item.');

				}
				$id = $item->getProduct()->getId();
				if (!$id){
					throw new Exception('invalid request.no product.');

				}
				$product = $item->getProduct();
				$store = $item->getStoreId();

				$cart->removeItem($cartid)->save();

				$this->_redirect('edoc/index/view',array('_query'=>array('id'=>$id,'item'=>$sess),'_store'=>$store,'_store_to_url'=>true,'_secure'=>true));

				return;
			} else {

			}
		} catch(SoapFault $e){
			Mage::logException($e);

		}
		catch(Exception $e){
			Mage::logException($e);

		}
		$msg = Mage::helper('edoc')->__('eDocBuilder server reopen the document session. You may try again.');
		Mage::getSingleton('core/session')->addError($msg );
		$this->_redirect('checkout/cart');
		return;
	}


	public function viewAction()
	{
		$id = $this->getRequest()->get('id');
		$cartid = $this->getRequest()->get('cartid', '');
		$params=$this->getRequest()->getParams();


		$product = Mage::getModel('catalog/product')->load($id);

		if(!$product||!$product->getId()){
			Mage::throwException("Invalid product");
			return;
		}

$eo=		Mage::getSingleton('checkout/session')->getData('edoc_options');

if(!$eo){
	$eo=array();
}
$ek=isset($params['edockey'])?$params['edockey']:false;
if(!$ek){

}else{
	unset($params['edockey']);
	$eo[$ek]=$params;
	Mage::getSingleton('checkout/session')->setData('edoc_options',$eo);
	$product->setEdocKey($ek);
}

		Mage::register('product', $product);
		$this->loadLayout();
		$this->renderLayout();
	}



	private function approve($sess)
	{
		return true;

		$endpoint = Mage::helper('edoc')->getConfig('endpoint', 'soapconfig');
		$client = new SoapClient($endpoint, array('cache_wsdl' => WSDL_CACHE_DISK));
		$response = $client->__soapCall('approveDocSession', array('approveDocSession' => array('docSessionID' => $sess)));




		if ($response->approveDocSessionResult->approvalStatus) {

			return true;

		}


		return false;

	}
	public function opAction(){

	}

	/**
	 * Action to which the customer will be returned when the payment is made.
	 */
	public function successAction()
	{
		try{
			$params=$this->getRequest()->getParams();

		$opts=	Mage::getSingleton('checkout/session')->getData('edoc_options');
			$ek=$this->getRequest()->get('edockey');
			$buyparams=array();
		if($ek&&$opts&&isset($opts[$ek])){
		$buyparams=$opts[$ek];
		}

			$sess = $this->getRequest()->getParam('docSession', '');
///			$sname = $this->getRequest()->getParam('docSession_id', '');
			$can = $this->getRequest()->getParam('docSessionCancelled', '');
			$pid = $this->getRequest()->getParam('magentoId', '');
			$cid = $this->getRequest()->getParam('cartid', '');
			$buy = array();
			$buy['sess'] = $sess;
///			$buy['sname'] = $sname;
			$buy['rand'] = time();
			$buy['qty'] = 1;
			Mage::log('entering success for '.$sess);

			if ($can==='false'){
				$can = false;
			}



			if (!$pid){
				Mage::logException('no pid');
				$this->_redirect('');
				return;
			}
			$product = Mage::getModel('catalog/product')->load($pid);

			if(!$product){
				throw new Exception("no product");
			}

			if ($can) {
				Mage::log('canceled');
				$msg=Mage::helper('edoc')->__('You have just cancelled the customization processs.');
				Mage::getSingleton('core/session')->addError($msg );
				$url = $product->getProductUrl();
				$this->_redirectUrl($url);
				return;
			}

			Mage::log('approved');
			$buyparams['sess']=$sess;

			$v = Mage::helper('edoc')->getPrv($sess);
			if ($v) {
				$buyparams['thumb'] = $v[0];
				$buyparams['large'] = $v[1];
			} else {
				$buyparams['thumb'] = false;
				$buyparams['large'] = false;
				$msg = Mage::helper('edoc')->__('Cannot retrieve preview image.');
				Mage::getSingleton('core/session')->addError($msg );

			}
			Mage::log('adding to crt');

			$cart = Mage::getSingleton('checkout/cart');

			$cart->init();


			$related = $this->getRequest()->getParam('related_product');
			$related=isset($buyparams['related_product'])?$buyparams['related_product']:'';


			$product->addCustomOption('aleyant_sess', $sess);
			$cart->addProduct($product, $buyparams);

			if (!empty($related)) {
				$cart->addProductsByIds(explode(',', $related));
			}



			$msg = Mage::helper('edoc')->__('The product is added to your cart.');

			Mage::getSingleton('core/session')->addSuccess($msg );
			$cart->save();


			Mage::getSingleton('checkout/session')->setCartWasUpdated(true);


			$this->_redirect('checkout/cart');

			return;


		}catch(Mage_Exception $e){
			Mage::logException($e);
			Mage::getSingleton('core/session')->addError($e->getMessage());

		}
		catch(Exception $e){
			Mage::logException($e);
			Mage::getSingleton('core/session')->addError($e->getMessage());

		}

		$this->_redirectUrl('/');
	}

	/**
	 * Action to which the customer will be returned if the payment process is
	 * cancelled.
	 * Cancel order and redirect user to the shopping cart.
	 */
	public function cancelAction()
	{
		echo "failed";
		exit;

	}



}